var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var EqptChangeDialog = (function (_super) {
    __extends(EqptChangeDialog, _super);
    function EqptChangeDialog() {
        _super.call(this);
        this.textList = new egret.gui.List();
        this.dp = new egret.gui.ArrayCollection();
    }
    EqptChangeDialog.prototype.createChildren = function () {
        _super.prototype.createChildren.call(this);
        this._dialog = new DialogBox();
        this.addElement(this._dialog);
        this._dialog.horizontalCenter = 0;
        this.m_UI = new UIChangeEqpt();
        this.addElement(this.m_UI);
        this.m_UI.horizontalCenter = 0;
        this._dialog._btn_close.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onTouch, this);
        this.m_UI.xz_btn_close.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onTouch, this);
        this._dialog._btn_help.visible = false;
        this._dialog.setTitle("装备选择");
        this.textList.skinName = "skins.ListSkin";
        this.textList.width = 522;
        this.textList.height = 335;
        this.textList.horizontalCenter = 0;
        this.addElement(this.textList);
        this.textList.itemRenderer = new egret.gui.ClassFactory(UIChangeEqptItemReader);
        this.textList.itemRendererSkinName = "skins.ChangeEqptItemReaderSkin";
        this.textList.dataProvider = this.dp;
        this.textList.addEventListener(egret.gui.ListEvent.ITEM_CLICK, this.clickItem, this);
        this.top = 30;
        this.m_UI.top = this.top + 40;
        this.textList.y = this.m_UI.y + 300;
    };
    EqptChangeDialog.prototype.clickItem = function (e) {
        var item = e.item;
        var operateObj = Main.player;
        if (Number(Main.player.m_operateObjid) > 0) {
            operateObj = Main.player.m_heros.heros[Main.player.m_operateObjid];
        }
        if (!operateObj || !(operateObj.id > 0))
            return;
        if (item.tpl["ejob"] != operateObj.job && Number(item.tpl["ejob"]) != 0)
            return;
        var url = "http://" + GameManager.server["ip"] + ":" + GameManager.server["port"];
        var param = "tagid=" + operateObj.id + "&objid=" + item["id"] + "&type=0x0005&sid=" + GameManager.SESSION_ID;
        HttpMessage.sendMsg(url, param);
        this.hide();
    };
    EqptChangeDialog.prototype.onTouch = function (e) {
        this.hide();
    };
    EqptChangeDialog.prototype.onUpdate = function () {
        this.dp.removeAll();
        this.m_UI.xz_label_null.visible = true;
        var operateObj = Main.player;
        if (Main.player.m_operateObjid > 0) {
            operateObj = Main.player.m_heros.heros[Main.player.m_operateObjid];
        }
        if (!operateObj)
            return;
        var tempArr = new Array();
        var canArr = new Array();
        for (var i in Main.player.m_items.equips) {
            var equip = Main.player.m_items.equips[i];
            if (equip && equip.tpl["ePostion"] == Main.player.m_clickIndex) {
                this.m_UI.xz_label_null.visible = false;
                if (equip.tpl["ejob"] == 0 || equip.tpl["ejob"] == operateObj.job) {
                    canArr.push(equip);
                }
                else {
                    tempArr.push(equip);
                }
            }
        }
        canArr.sort(function (x, y) {
            if (y.grade > x.grade)
                return 1;
            else if (y.grade == x.grade) {
                if (y["qly"] > x["qly"])
                    return 1;
                else if (y["qly"] == x["qly"]) {
                    if (y.tpl['lv'] > x.tpl['lv'])
                        return 1;
                }
            }
            return -1;
        });
        for (var i in canArr) {
            this.dp.addItem(canArr[i]);
        }
        for (var i in tempArr) {
            this.dp.addItem(tempArr[i]);
        }
        if (Main.player.m_clickItme) {
            this.m_UI.xz_icon.data = Main.player.m_clickItme;
            this.m_UI.xz_icon.dataChanged();
            this.m_UI.xz_label_property.text = GameManager.GetEqptPropStr(Main.player.m_clickItme);
            this.m_UI.xz_label_property.textColor = GameManager.COLOR[Number(Main.player.m_clickItme["qly"])];
        }
        else {
            this.m_UI.xz_label_property.text = "";
            this.m_UI.xz_icon.setCount("");
            this.m_UI.xz_icon.setItems("test_icon");
            this.m_UI.xz_icon.setName("");
            this.m_UI.xz_icon.setQuality(0);
            this.m_UI.xz_icon.setText("");
            this.m_UI.xz_icon.setStrength("");
            this.m_UI.xz_icon.setEffVis();
            this.m_UI.xz_icon._group.removeAllElements();
            this.m_UI.xz_icon.data = null;
        }
        if (this.dp.length < 3) {
            var self = this;
            egret.callLater(function () {
                self.textList.dataGroup.verticalScrollPosition = 0;
            }, this.textList);
        }
    };
    EqptChangeDialog.prototype.show = function () {
        _super.prototype.show.call(this);
        this.onUpdate();
    };
    EqptChangeDialog.prototype.hide = function () {
        _super.prototype.hide.call(this);
    };
    return EqptChangeDialog;
})(Dialog);
