/**
 * Copyright (c) 2014,Egret-Labs.org
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the Egret-Labs.org nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY EGRET-LABS.ORG AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL EGRET-LABS.ORG AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
var egret;
(function (egret) {
    var gui;
    (function (gui) {
        /**
         * @class egret.gui.PropertyChangeEventKind
         * @classdesc
         * PropertyChangeEventKind 类定义 PropertyChangeEvent 类的 kind 属性的常量值。
         */
        var PropertyChangeEventKind = (function () {
            function PropertyChangeEventKind() {
            }
            /**
             * 指示该属性的值已更改。
             * @constant egret.gui.PropertyChangeEventKind.UPDATE
             */
            PropertyChangeEventKind.UPDATE = "update";
            /**
             * 指示该属性已从此对象中删除。
             * @constant egret.gui.PropertyChangeEventKind.DELETE
             */
            PropertyChangeEventKind.DELETE = "delete";
            return PropertyChangeEventKind;
        })();
        gui.PropertyChangeEventKind = PropertyChangeEventKind;
        PropertyChangeEventKind.prototype.__class__ = "gui.PropertyChangeEventKind";
    })(gui = egret.gui || (egret.gui = {}));
})(egret || (egret = {}));
