/**
 * Copyright (c) 2014,Egret-Labs.org
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the Egret-Labs.org nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY EGRET-LABS.ORG AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL EGRET-LABS.ORG AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
var egret;
(function (egret) {
    var gui;
    (function (gui) {
        /**
         * @class egret.gui.ColumnAlign
         * @classdesc
         * ColumnAlign 类为 TileLayout 类的 columnAlign 属性定义可能的值。
         */
        var ColumnAlign = (function () {
            function ColumnAlign() {
            }
            /**
             * 不将行两端对齐。
             * @constant egret.gui.ColumnAlign.LEFT
             */
            ColumnAlign.LEFT = "left";
            /**
             * 通过增大水平间隙将行两端对齐。
             * @constant egret.gui.ColumnAlign.JUSTIFY_USING_GAP
             */
            ColumnAlign.JUSTIFY_USING_GAP = "justifyUsingGap";
            /**
             * 通过增大行高度将行两端对齐。
             * @constant egret.gui.ColumnAlign.JUSTIFY_USING_WIDTH
             */
            ColumnAlign.JUSTIFY_USING_WIDTH = "justifyUsingWidth";
            return ColumnAlign;
        })();
        gui.ColumnAlign = ColumnAlign;
        ColumnAlign.prototype.__class__ = "gui.ColumnAlign";
    })(gui = egret.gui || (egret.gui = {}));
})(egret || (egret = {}));
